Index: trunk/src/Makefile
===================================================================
--- trunk/src/Makefile	(revision 21)
+++ trunk/src/Makefile	(revision 21)
@@ -0,0 +1,141 @@
+# define which programs this effects
+PROGS			= 	libRpUnits_CInterface 	\
+					libRpUnits_FInterface 	\
+					librappture				\
+					libRapptureIO			\
+
+# define our compiling environment
+# 
+AR				= ar
+CC 				= gcc
+CPP				= g++
+DEBUG	 		= -g -Wall
+DEBUG_PLUS 		= -g -DDEBUG
+
+# FORTRAN BINDINGS COMPILER FLAGS 
+#
+# available flags
+#
+# 	COMPNAME_NOCHANGE		- 	No change to the Rappture Library function 
+# 								name
+# 	COMPNAME_UPPERCASE  	-	Replace the Rappture Library function name 
+# 								with an all uppercase version of the name
+# 	COMPNAME_ADD1UNDERSCORE	-	add 1 underscore to the end of the Rappture 
+# 								Library function name
+# 	COMPNAME_ADD2UNDERSCORE	-	add 2 underscores to the end of the Rappture 
+# 								Library function name
+# 
+# when setting CFLAGS, use the following guide for help
+#
+# gnu's g77/f77			COMPNAME_ADD2UNDERSCORE
+# absoft's f77			COMPNAME_ADD1UNDERSCORE
+# intel's ifort 		COMPNAME_ADD1UNDERSCORE
+# intel's mpif90		COMPNAME_ADD1UNDERSCORE
+#
+#
+
+CFLAGS 			= -DCOMPNAME_ADD2UNDERSCORE
+
+ F77			= g77
+#F77				= f77
+#F77				= ifort
+#F77				= /opt/mpich-1.2.6/p4-intel/bin/mpif90
+
+LN              = ln
+
+# define our directories
+#
+WORK_DIR 		= ../work
+INCLUDES_DIR 	= ../include
+SRC_DIR 		= core
+FORT_SRC		= fortran
+CEE_SRC			= cee
+PY_SRC			= python
+BIN_DIR			= ../bin
+LIB_DIR			= ../lib
+
+#LIB_RPUNITS 	= -Wl,-rpath,$(LIB_DIR) -L$(LIB_DIR) -lRpUnits
+#LIB_RPDICT 		= -Wl,-rpath,$(LIB_DIR) -L$(LIB_DIR) -lRpDict
+
+LIB_RPUNITS_C 	= -Wl,-rpath,$(LIB_DIR) -L$(LIB_DIR) -lRpUnits_CInterface
+LIB_RPUNITS_F 	= -Wl,-rpath,$(LIB_DIR) -L$(LIB_DIR) -lRpUnits_FInterface
+LIB_RAPPTURE 	= -Wl,-rpath,$(LIB_DIR) -L$(LIB_DIR) -lrappture
+LIB_RAPPTUREIO	= -Wl,-rpath,$(LIB_DIR) -L$(LIB_DIR) -lRapptureIO
+
+INCL_CORE 		= -I $(INCLUDES_DIR)/core
+INCL_CEE		= -I $(INCLUDES_DIR)/cee
+INCL_FORTRAN	= -I $(INCLUDES_DIR)/fortran
+INCL_PY			= -I $(INCLUDES_DIR)/python
+
+# you need to change this to where your version of python is installed.
+EMB_PY_FLAGS    = -L$(LIB_DIR) -lpython2.4
+
+# tell make where to find files of each specific type
+#
+vpath %.o $(WORK_DIR)
+vpath %.so $(LIB_DIR)
+vpath %.h $(INCLUDES_DIR)
+#vpath %.c $(SRC_DIR)
+#vpath %.cc $(SRC_DIR)
+#vpath %.tcc $(SRC_DIR)
+#vpath %.cpp $(SRC_DIR)
+
+
+# default: 
+
+all: ${PROGS}
+
+#### librappture shared object ###########################################
+
+libRpUnits_CInterface: $(WORK_DIR)/RpUnitsCInterface.o $(WORK_DIR)/RpUnitsStd.o $(WORK_DIR)/RpUnits.o
+	$(CPP) $(DEGUG) -shared -Wl,-rpath,../lib \
+		-Wl,-soname,$@.so -o $(LIB_DIR)/$@.so.0.0 $^ -lc
+	
+	/sbin/ldconfig -n $(LIB_DIR)
+
+libRpUnits_FInterface: $(WORK_DIR)/RpUnitsStd.o $(WORK_DIR)/RpUnits.o $(WORK_DIR)/RpUnits_fortran.o 
+	$(CPP) $(DEBUG) -shared -Wl,-rpath,../lib \
+        -Wl,-soname,$@.so -o $(LIB_DIR)/$@.so.0.0 $^ -lstdc++
+	
+	/sbin/ldconfig -n $(LIB_DIR)
+
+librappture: $(WORK_DIR)/rappture_fortran.o $(WORK_DIR)/rappture_interface.o
+	$(CC) $(DEGUG) -shared -Wl,-rpath,../lib \
+		-Wl,-soname,$@.so -o $(LIB_DIR)/$@.so.0.0 $^ $(EMB_PY_FLAGS) -lstdc++
+		
+	/sbin/ldconfig -n $(LIB_DIR)
+    
+libRapptureIO: $(WORK_DIR)/rappture_fortran.o $(WORK_DIR)/rappture_interface.o
+	$(CC) $(DEGUG) -shared -Wl,-rpath,../lib \
+		-Wl,-soname,$@.so -o $(LIB_DIR)/$@.so.0.0 $^ $(EMB_PY_FLAGS) -lstdc++ 
+		
+	/sbin/ldconfig -n $(LIB_DIR)
+    
+
+# -fPIC is for Platform Independent Code, used when creating shared objects.
+
+$(WORK_DIR)/RpUnits.o: $(SRC_DIR)/RpUnits.cc 
+	$(CPP) -fPIC $(DEBUG) $(INCL_CORE) -o $@ -c $?
+
+$(WORK_DIR)/RpUnitsStd.o: $(SRC_DIR)/RpUnitsStd.cc
+	$(CPP) -fPIC $(DEBUG) $(INCL_CORE) -o $@ -c $?
+
+$(WORK_DIR)/RpDict.o: $(SRC_DIR)/RpDict.cc
+	$(CPP) -fPIC $(DEBUG) $(INCL_CORE) -o $@ -c $?
+
+$(WORK_DIR)/rappture_interface.o: $(CEE_SRC)/rappture_interface.c
+	$(CPP) -fPIC $(DEBUG) $(INCL_CEE) -o $(WORK_DIR)/$@ -c $<
+
+$(WORK_DIR)/RpUnitsCInterface.o: $(CEE_SRC)/RpUnitsCInterface.cc
+	$(CPP) $(CFLAGS) -fPIC $(DEBUG) $(INCL_CORE) $(INCL_CEE)  -o $@ -c $?
+
+$(WORK_DIR)/RpUnits_fortran.o: $(FORT_SRC)/RpUnits_fortran.c
+	$(CPP) $(CFLAGS) -fPIC $(DEBUG) $(INCL_CORE) -o $@ -c $?
+
+$(WORK_DIR)/rappture_fortran.o: $(FORT_SRC)/rappture_fortran.c
+	$(CPP) $(CFLAGS) -fPIC $(DEBUG) $(INCL_CORE) $(INCL_CEE) -o $(WORK_DIR)/$@ -c $<
+
+
+#### CLEAN UP ############################################################
+clean: 
+	- rm -f $(BIN_DIR)/* $(WORK_DIR)/*.o
Index: trunk/src/README
===================================================================
--- trunk/src/README	(revision 21)
+++ trunk/src/README	(revision 21)
@@ -0,0 +1,29 @@
+To compile the Rappture Library, the following must be done:
+
+1) Adjust the Makefile.
+
+    Change Makefile variables as needed. Pay particular attention to
+    compilers, CFLAGS, directory names, and where python components
+    are located. Make sure you change the variable 'EMB_PY_FLAGS' 
+    to point to the location of the python shared (or static) object
+    library is located. It can be placed in the lib directory directly
+    above this directory.
+
+2) Adjust the file 'include/cee/rappture_interface.h'
+
+    Line 1 of rappture_interface.h includes 'python2.4/Python.h'.
+    Make sure this file (and all of its supporting files) exist
+    in the directory 'include/cee/'. Replace 'python2.4/Python.h'
+    with the version of python being used and the location where
+    Python.h can be found. Python.h and all of its suppoting files
+    can be downloaded from http://www.python.org/download/. You
+    will only need the header files to fulfill this task.
+    If you do not have a python object library, you will need to
+    compile python with the appropriate flags (--enable-shared) to
+    get it. 
+    
+3) Make sure the Rappture module is installed in Python.
+
+4) Make a library
+    
+    make librappture
Index: trunk/src/cee/RpUnitsCInterface.cc
===================================================================
--- trunk/src/cee/RpUnitsCInterface.cc	(revision 20)
+++ trunk/src/cee/RpUnitsCInterface.cc	(revision 21)
@@ -1,4 +1,4 @@
-#include "../include/RpUnits.h"
-#include "../include/RpUnitsCInterface.h"
+#include "RpUnits.h"
+#include "RpUnitsCInterface.h"
 
 #ifdef __cplusplus
Index: trunk/src/cee/rappture_interface.c
===================================================================
--- trunk/src/cee/rappture_interface.c	(revision 20)
+++ trunk/src/cee/rappture_interface.c	(revision 21)
@@ -1,3 +1,3 @@
-#include "../include/rappture_interface.h"
+#include "rappture_interface.h"
 
 /**********************************************************************/
Index: trunk/src/core/RpUnits.cc
===================================================================
--- trunk/src/core/RpUnits.cc	(revision 20)
+++ trunk/src/core/RpUnits.cc	(revision 21)
@@ -1,4 +1,4 @@
  #ifndef _RpUNITS_H
-     #include "../include/RpUnits.h"
+     #include "RpUnits.h"
  #endif
 
Index: trunk/src/fortran/RpUnits_fortran.c
===================================================================
--- trunk/src/fortran/RpUnits_fortran.c	(revision 20)
+++ trunk/src/fortran/RpUnits_fortran.c	(revision 21)
@@ -3,6 +3,6 @@
 // #include <stdio.h>
 
-#include "../include/RpUnits.h"
-#include "../include/RpDict.h"
+#include "RpUnits.h"
+#include "RpDict.h"
 #include "string.h"
 
Index: trunk/src/fortran/rappture_fortran.c
===================================================================
--- trunk/src/fortran/rappture_fortran.c	(revision 20)
+++ trunk/src/fortran/rappture_fortran.c	(revision 21)
@@ -1,4 +1,4 @@
-#include "../include/rappture_interface.h"
-#include "../include/RpDict.h"
+#include "rappture_interface.h"
+#include "RpDict.h"
 #include <string.h>
 
Index: trunk/src/python/PyRpUnits_setup.py
===================================================================
--- trunk/src/python/PyRpUnits_setup.py	(revision 21)
+++ trunk/src/python/PyRpUnits_setup.py	(revision 21)
@@ -0,0 +1,15 @@
+from distutils.core import setup, Extension
+
+module = Extension('RpUnits',
+                   include_dirs = [ '/usr/local/include',
+                                    '../../include/cee',
+                                    '../../include/core'],
+                   libraries = ['RpUnits'],
+                   library_dirs = ['../lib'],
+                   sources = ['src/PyRpUnits.cc'])
+
+setup(name="RpUnits",
+      version="0.1",
+      description="module for converting Rappture Units",
+      ext_modules=[module])
+