Index: trunk/examples/app-fermi/tool.xml
===================================================================
--- trunk/examples/app-fermi/tool.xml	(revision 31)
+++ trunk/examples/app-fermi/tool.xml	(revision 32)
@@ -3,18 +3,14 @@
     <tool>
         <about>Press Simulate to view results.</about>
-        <command> put run-command here </command>
+        <command> @tool/fermi @driver</command>
     </tool>
     <input>
-        <!-- this temp should be moved to a more global scope -->
         <group id="ambient">
             <number id="temperature">
-                <about>
-                    <label>Ambient temperature</label>
-                </about>
+                <label>Ambient temperature</label>
                 <units>K</units>
                 <min>120K</min>
                 <max>500K</max>
-                <default>300</default>
-                <current>300</current>
+                <default>300K</default>
                 <preset>
                     <value>400K</value>
@@ -31,620 +27,12 @@
             </number>
         </group>
-        <group id="simulation_params">
-            <group id="handle">
-                <!-- more like yes or no flags -->
-                <string id="comments">
-                    <label>comments</label>
-                    <default>off</default>
-                    <current>off</current>
-                </string>
-                <boolean id="iflag3B">
-                    <label>iflag3B</label>
-                    <default>0</default>
-                    <current>0</current>
-                </boolean>
-                <boolean id="iflagPOI">
-                    <label>iflagPOI</label>
-                    <default>1</default>
-                    <current>0</current>
-                </boolean>
-                <number id="iterPOImax">
-                    <label>iterPOImax</label>
-                    <min>0</min>
-                    <max>200</max>
-                    <default>10</default>
-                    <current>0</current>
-                </number>
-                <number id="intiterPOImax">
-                    <label>intiterPOImax</label>
-                    <min>0</min>
-                    <max>200</max>
-                    <default>5</default>
-                    <current>5</current>
-                </number>
-                <number id="ndampPOI">
-                    <label>ndampPOI</label>
-                    <min>0</min>
-                    <max>1000</max>
-                    <default>500</default>
-                    <current>500</current>
-                </number>
-                <number id="normPOI">
-                    <label>normPOI</label>
-                    <min>0</min>
-                    <max>1</max>
-                    <default>1.0e-4</default>
-                    <current>1.0e-4</current>
-                </number>
-                <string id="simtype">
-                    <label>simtype</label>
-                    <default>Q</default>
-                    <current>Q</current>
-                </string>
-                <boolean id="iflagGL">
-                    <label>iflagGL</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-                <boolean id="iflagGG">
-                    <label>iflagGG</label>
-                    <default>0</default>
-                    <current>0</current>
-                </boolean>
-                <boolean id="iflagBAC">
-                    <label>iflagBAC</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-            </group>
-            <group id="outwrite">
-                <string id="extension">
-                    <label>Filename Extension</label>
-                    <default>_DG.txt</default>
-                    <current>_DG.txt</current>
-                </string>
-                <boolean id="iwritePROF">
-                    <label>iwritePROF</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-                <boolean id="iwritePROFduringPOI">
-                    <label>iwritePROFduringPOI</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-                <boolean id="iwriteCURvsE">
-                    <label>iwriteCURvsE</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-                <boolean id="iwriteDOSvsE">
-                    <label>iwriteDOSvsE</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-                <boolean id="iwriteSIGcvsE">
-                    <label>iwriteSIGcvsE</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-                <boolean id="iwriteSIGcvsE1D">
-                    <label>iwriteSIGcvsE1D</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-                <boolean id="iwriteCURvsY">
-                    <label>iwriteCURvsY</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-                <boolean id="iwriteEres">
-                    <label>iwriteEres</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-                <boolean id="iwritePSIsq">
-                    <label>iwritePSIsq</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-                <boolean id="iwriteTRAN">
-                    <label>iwriteTRAN</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-                <boolean id="iwriteIV">
-                    <label>iwriteIV</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-                <boolean id="iwriteINGUESS">
-                    <label>iwriteINGUESS</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-                <boolean id="iwriteDOPI">
-                    <label>iwriteDOPI</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-                <boolean id="iwriteGRID">
-                    <label>iwriteGRID</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-                <boolean id="iwriteEGRID">
-                    <label>iwriteEGRID</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-                <boolean id="iwriteMATERIAL">
-                    <label>iwriteMATERIAL</label>
-                    <default>1</default>
-                    <current>1</current>
-                </boolean>
-            </group>
-        </group>
-        <!-- this group should be removed, its structure is properly defined below -->
-        <group id="2dmosfet">
-            <number id="Lx">
-                <label>x simulation width</label>
-                <units>nm</units>
-                <min>0nm</min>
-                <max>1000nm</max>
-                <default>10</default>
-                <current>24</current>
-            </number>
-            <number id="Ly">
-                <label>y simulation length</label>
-                <units>nm</units>
-                <min>0nm</min>
-                <max>1000nm</max>
-                <default>10</default>
-                <current>40</current>
-            </number>
-        </group>
-        <group id="energy">
-            <number id="ksize">
-                <label>total egrid size</label>
-                <units></units>
-                <default>512</default>
-                <current>256</current>
-            </number>
-            <number id="ksize_un">
-                <label>uniform background grid</label>
-                <units></units>
-                <default>56</default>
-                <current>56</current>
-            </number>
-            <string id="type">
-                <label>type of energy grid</label>
-                <default>nonuniform</default>
-                <current>nonuniform</current>
-            </string>
-            <number id="lower_energy_grid">
-                <label>lower limit of energy grid</label>
-                <units></units>
-                <default>-1000</default>
-                <current>-1000.0</current>
-            </number>
-            <number id="higher_energy_grid">
-                <label>higher limit of energy grid</label>
-                <units></units>
-                <default>1000</default>
-                <current>1000.0</current>
-            </number>
-            <number id="high_energy_tail_cutoff">
-                <label>high energy tail cutoff</label>
-                <units></units>
-                <default>10</default>
-                <current>10.0</current>
-            </number>
-            <number id="lower_energy_tail_cutoff">
-                <label>lower energy tail cutoff</label>
-                <units></units>
-                <default>3</default>
-                <current>3.0</current>
-            </number>
-            <boolean id="iflagRES">
-                    <label>iflagRES</label>
-                    <default>1</default>
-                    <current>1</current>
-            </boolean>
-        </group>
-        <structure id="str">
-            <current id = "cur">
-              <!-- numeric parameters to be set by user in gui -->
-              <!-- variables describing the geometry of boxes-->
-              <parameters id="param">
-                <number id="Ly">
-                  <about>
-                    <label>Domain Length</label>
-                  </about>
-                  <units>nm</units>
-                  <default>40nm</default>
-                  <current>40nm</current>
-                </number>
-                <number id="Lx">
-                  <about>
-                    <label>Domain Width</label>
-                  </about>
-                  <units>nm</units>
-                  <default>24nm</default>
-                  <current>24nm</current>
-                </number>
-                <number id="SDlength">
-                  <about>
-                    <label>Source / Drain Width</label>
-                  </about>
-                  <units>nm</units>
-                  <default>14nm</default>
-                  <current>14nm</current>
-                </number>
-                <number id="SDwidth">
-                  <about>
-                    <label>Source / Drain Width</label>
-                  </about>
-                  <units>nm</units>
-                  <default>14nm</default>
-                  <current>14nm</current>
-                </number>
-                <number id="ChannelLength">
-                  <about>
-                    <label>Channel Length</label>
-                  </about>
-                  <units>nm</units>
-                  <default>12nm</default>
-                  <current>12nm</current>
-                </number>
-                <number id="ChannelWidth">
-                  <about>
-                    <label>Channel Width</label>
-                  </about>
-                  <units>nm</units>
-                  <default>2nm</default>
-                  <current>2nm</current>
-                </number>
-                <number id="TopOxideThickness">
-                  <about>
-                    <label>Top Oxide Thickness</label>
-                  </about>
-                  <units>nm</units>
-                  <default>1.5nm</default>
-                  <current>1.5nm</current>
-                </number>
-                <number id="BotOxideThickness">
-                  <about>
-                    <label>Bottom Oxide Thickness</label>
-                  </about>
-                  <units>nm</units>
-                  <default>1.5nm</default>
-                  <current>1.5nm</current>
-                </number>
-                <number id="GateLength">
-                  <about>
-                    <label>Gate Length</label>
-                  </about>
-                  <units>nm</units>
-                  <default>10nm</default>
-                  <current>10nm</current>
-                </number>
-                <number id="NxGridTopOxide">
-                 <label>No. of grid (nx) in Top Oxide</label>
-                 <units></units>
-                 <default>5</default>
-                 <current>5</current>
-                </number>
-                <number id="NxGridChannel">
-                 <label>No. of grid (nx) in Channel</label>
-                 <units></units>
-                 <default>15</default>
-                 <current>15</current>
-                </number>
-                <number id="NxGridBottomOxide">
-                 <label>No. of grid (nx) in Bottom Oxide </label>
-                 <units></units>
-                 <default>5</default>
-                 <current>5</current>
-                </number>
-                <number id="GridSizeY">
-                 <label>Grid Size (DeltaY)</label>
-                 <units>nm</units>
-                 <default>0.25nm</default>
-                 <current>0.4nm</current>
-                </number>
-                <group id="ix_contact">
-                    <number id="first">
-                      <default>2</default>
-                      <current>2</current>
-                    </number>
-                    <number id="last">
-                      <default>8</default>
-                      <current>8</current>
-                    </number>
-                </group>
-                <group id="iy_contact">
-                    <number id="first">
-                      <default>1</default>
-                      <current>1</current>
-                    </number>
-                    <number id="last">
-                      <default>1</default>
-                      <current>1</current>
-                    </number>
-                </group>
-                <group id="ix_coupling">
-                    <number id="first">
-                      <default>2</default>
-                      <current>2</current>
-                    </number>
-                    <number id="last">
-                      <default>8</default>
-                      <current>8</current>
-                    </number>
-                </group>
-                <group id="iy_coupling">
-                    <number id="first">
-                      <default>1</default>
-                      <current>1</current>
-                    </number>
-                    <number id="last">
-                      <default>1</default>
-                      <current>1</current>
-                    </number>
-                </group>
-                <!-- this is the only user modified value -->
-                <group id="source">
-                    <number id="voltage">
-                      <about>
-                        <label>Source Voltage</label>
-                      </about>
-                      <units>mV</units>
-                      <min>0mV</min> 
-                      <default>0mV</default>
-                      <current>0mV</current>
-                    </number>
-                </group> <!-- end source -->
-                <group id="drain">
-                    <number id="voltage">
-                      <about>
-                        <label>Drain Voltage</label>
-                      </about>
-                      <units>mV</units>
-                      <min>0mV</min> 
-                      <default>0mV</default>
-                      <current>600mV</current>
-                    </number>
-                </group>
-                <group id="gate">
-                    <number id="voltage">
-                      <about>
-                        <label>Gate Voltage</label>
-                      </about>
-                      <units>mV</units>
-                      <min>0mV</min> 
-                      <default>0mV</default>
-                      <current>0mV</current>
-                    </number>
-                </group>
-                <number id="num_contacts">
-                  <about>
-                    <label>number of contacts with varying bias</label>
-                  </about>
-                  <units></units>
-                  <default>1</default>
-                  <current>2</current>
-                </number>
-                <!-- it would be better if we could get the 
-                     next 4 variables into 1 var -->
-                <number id="varying_contact1">
-                  <about>
-                    <label>contact with varying bias</label>
-                    <!-- 
-                        1 - source 
-                        2 - drain
-                        3 - bottom gate
-                        4 - top gate
-                    -->
-                  </about>
-                  <units></units>
-                  <default>0</default>
-                  <current>3</current>
-                </number>
-                <number id="varying_contact2">
-                  <about>
-                    <label>contact with varying bias</label>
-                    <!-- 
-                        1 - source 
-                        2 - drain
-                        3 - bottom gate
-                        4 - top gate
-                    -->
-                  </about>
-                  <units></units>
-                  <default>0</default>
-                  <current>4</current>
-                </number>
-                <number id="varying_contact3">
-                  <about>
-                    <label>contact with varying bias</label>
-                    <!-- 
-                        1 - source 
-                        2 - drain
-                        3 - bottom gate
-                        4 - top gate
-                    -->
-                  </about>
-                  <units></units>
-                  <default>0</default>
-                  <current>0</current>
-                </number>
-                <number id="varying_contact4">
-                  <about>
-                    <label>contact with varying bias</label>
-                    <!-- 
-                        1 - source 
-                        2 - drain
-                        3 - bottom gate
-                        4 - top gate
-                    -->
-                  </about>
-                  <units></units>
-                  <default>0</default>
-                  <current>0</current>
-                </number>
-                <number id="bias_min">
-                  <about>
-                    <label>Min Applied Voltage</label>
-                  </about>
-                  <units>mV</units>
-                  <min>0mV</min> 
-                  <default>0mV</default>
-                  <current>0mV</current>
-                </number>
-                <number id="bias_max">
-                  <about>
-                    <label>Max Applied Voltage</label>
-                  </about>
-                  <units>mV</units>
-                  <min>0mV</min> 
-                  <default>0mV</default>
-                  <current>0mV</current>
-                </number>
-                <number id="bias_step">
-                  <about>
-                    <label>Applied Voltage Step</label>
-                  </about>
-                  <units>mV</units>
-                  <min>0mV</min> 
-                  <default>100mV</default>
-                  <current>100mV</current>
-                </number>
-              </parameters>
-              <!-- the following describes the box dimensions -->
-              <components>
-                <box>
-                  <about>
-                    <label>Source</label>
-                    <color>yellow</color>
-                  </about>
-                  <corner>-20,-7</corner>
-                  <corner>-6,7</corner>
-                  <material>Si</material>
-                </box>
-                <box>
-                  <about>
-                    <label>Drain</label>
-                    <color>yellow</color>
-                  </about>
-                  <corner>20,-7</corner>
-                  <corner>6,7</corner>
-                  <material>Si</material>
-                </box>
-                <box>
-                  <about>
-                    <label>Channel</label>
-                    <color>yellow</color>
-                  </about>
-                  <corner>-6,-1</corner>
-                  <corner>6,1</corner>
-                  <material>Si</material>
-                </box>
-                <box>
-                  <about>
-                    <label>Top Oxide</label>
-                    <color>yellow</color>
-                  </about>
-                  <corner>,-5,-2.5</corner>
-                  <corner>5,-1</corner>
-                  <material>Oxide1</material>
-                </box>
-                <box>
-                  <about>
-                    <label>Bottom Oxide</label>
-                    <color>yellow</color>
-                  </about>
-                  <corner>-5,1</corner>
-                  <corner>5,2.5</corner>
-                  <material>Oxide</material>
-                </box>
-              </components>
-              <!-- the following describes the user defined material specs  -->
-              <domain_materials>
-                <material name="Si">
-                    <properties id="transport">
-                        <emiso>0.328</emiso>
-                        <emx>0.98</emx>
-                        <emy>0.98</emy>
-                        <emz>0.98</emz>
-                        <hmiso>0.49</hmiso>
-                        <eps>11.9</eps>
-                        <Egap>1.12D03</Egap>
-                        <affinity>4.05D03</affinity>
-                    </properties>
-                </material>
-                <material name="SiO2">
-                    <properties id="transport">
-                        <emiso>0.5</emiso>
-                        <emx>0.5</emx>
-                        <emy>0.5</emy>
-                        <emz>0.5</emz>
-                        <hmiso>0.5</hmiso>
-                        <eps>3.9</eps>
-                        <Egap>8.8D03</Egap>
-                        <affinity>0.95D03</affinity>
-                    </properties>
-                </material>
-                <material name="Metal">
-                    <properties id="transport">
-                        <emiso>0.328</emiso>
-                        <emx>0.98</emx>
-                        <emy>0.19</emy>
-                        <emz>0.19</emz>
-                        <hmiso>0.49</hmiso>
-                        <eps>11.9</eps>
-                        <Egap>1.12D03</Egap>
-                        <affinity>4.42270D03</affinity>
-                    </properties>
-                </material>
-                <material name="Metal1">
-                    <properties id="transport">
-                        <emiso>0.328</emiso>
-                        <emx>0.98</emx>
-                        <emy>0.19</emy>
-                        <emz>0.19</emz>
-                        <hmiso>0.49</hmiso>
-                        <eps>11.9</eps>
-                        <Egap>1.12D03</Egap>
-                        <affinity>4.42270D03</affinity>
-                    </properties>
-                </material>
-                <material name="Oxide">
-                    <properties id="transport">
-                        <emiso>0.5</emiso>
-                        <emx>0.5</emx>
-                        <emy>0.5</emy>
-                        <emz>0.5</emz>
-                        <hmiso>0.5</hmiso>
-                        <eps>3.9</eps>
-                        <Egap>8.8D03</Egap>
-                        <affinity>0.95D03</affinity>
-                    </properties>
-                </material>
-                <material name="Oxide1">
-                    <properties id="transport">
-                        <emiso>0.5</emiso>
-                        <emx>0.5</emx>
-                        <emy>0.5</emy>
-                        <emz>0.5</emz>
-                        <hmiso>0.5</hmiso>
-                        <eps>3.9</eps>
-                        <Egap>8.8D03</Egap>
-                        <affinity>0.95D03</affinity>
-                    </properties>
-                </material>
-              </domain_materials>
-            </current>
-        </structure>
+        <number id="Ef">
+            <label>Fermi Level</label>
+            <units>eV</units>
+            <min>-10eV</min>
+            <max>10eV</max>
+            <default>-5.5eV</default>
+        </number>
     </input>
 </run>
+