Index: /trunk/src/Makefile
===================================================================
--- /trunk/src/Makefile	(revision 38)
+++ /trunk/src/Makefile	(revision 39)
@@ -12,4 +12,12 @@
 					librappture				\
 					libRapptureIO			\
+					libRpUnits				\
+					libRpVariable			\
+					libRpNumber				\
+					libRpString				\
+					libRpBoolean			\
+					libRpChoice				\
+					libRpOption				
+					
 
 # define our compiling environment
@@ -43,10 +51,10 @@
 #
 
-CFLAGS 			= -DCOMPNAME_ADD1UNDERSCORE
+CFLAGS 			= -DCOMPNAME_ADD2UNDERSCORE
 
-#F77		        = g77
+F77		        = g77
 #F77				= f77
 #F77				= ifort
-F77				= /opt/mpich-1.2.6/p4-intel/bin/mpif90
+#F77				= /opt/mpich-1.2.6/p4-intel/bin/mpif90
 
 LN              = ln
@@ -67,4 +75,19 @@
 #LIB_RPUNITS 	= -Wl,-rpath,$(LIB_DIR) -L$(LIB_DIR) -lRpUnits
 #LIB_RPDICT 		= -Wl,-rpath,$(LIB_DIR) -L$(LIB_DIR) -lRpDict
+
+LIB_INC_PREFIX	= -Wl,-rpath,$(LIB_DIR) -L$(LIB_DIR)
+
+#LIB_RPUNITS_C   = $(LIB_INC_PREFIX) -lRpUnits_CInterface
+#LIB_RAPPTUREIO  = $(LIB_INC_PREFIX) -lrappture
+
+LIB_RP_UNITS 	= $(LIB_INC_PREFIX) -lRpUnits
+LIB_RP_VARIABLE = $(LIB_INC_PREFIX) -lRpVariable
+LIB_RP_NUMBER 	= $(LIB_INC_PREFIX) -lRpNumber
+LIB_RP_STRING 	= $(LIB_INC_PREFIX) -lRpString
+LIB_RP_BOOLEAN 	= $(LIB_INC_PREFIX) -lRpBoolean
+LIB_RP_OPTION 	= $(LIB_INC_PREFIX) -lRpOption
+LIB_RP_CHOICE 	= $(LIB_INC_PREFIX) -lRpChoice
+LIB_RP_PRESET 	= $(LIB_INC_PREFIX) -lRpPreset
+
 
 LIB_RPUNITS_C 	= -Wl,-rpath,$(LIB_DIR) -L$(LIB_DIR) -lRpUnits_CInterface
@@ -108,5 +131,4 @@
 include $(FORT_SRC)/make.inc
 
-    
 #### CLEAN UP ############################################################
 clean: 
Index: /trunk/src/core/make.inc
===================================================================
--- /trunk/src/core/make.inc	(revision 38)
+++ /trunk/src/core/make.inc	(revision 39)
@@ -1,29 +1,2 @@
-$(WORK_DIR)/RpUnits.o: $(SRC_DIR)/RpUnits.cc 
+$(WORK_DIR)/Rp%.o: $(CORE_SRC)/Rp%.cc 
 	$(CPP) -fPIC $(DEBUG) $(INCL_CORE) -o $@ -c $?
-
-$(WORK_DIR)/RpUnitsStd.o: $(SRC_DIR)/RpUnitsStd.cc
-	$(CPP) -fPIC $(DEBUG) $(INCL_CORE) -o $@ -c $?
-
-$(WORK_DIR)/RpDict.o: $(SRC_DIR)/RpDict.cc
-	$(CPP) -fPIC $(DEBUG) $(INCL_CORE) -o $@ -c $?
-
-$(WORK_DIR)/RpVariable.o: $(SRC_DIR)/RpVariable.cc
-	$(CPP) -fPIC $(DEBUG) $(INCL_CORE) -o $@ -c $?
-
-$(WORK_DIR)/RpNumber.o: $(SRC_DIR)/RpNumber.cc
-	$(CPP) -fPIC $(DEBUG) $(INCL_CORE) -o $@ -c $?
-
-$(WORK_DIR)/RpString.o: $(SRC_DIR)/RpString.cc
-	$(CPP) -fPIC $(DEBUG) $(INCL_CORE) -o $@ -c $?
-
-$(WORK_DIR)/RpChoice.o: $(SRC_DIR)/RpChoice.cc
-	$(CPP) -fPIC $(DEBUG) $(INCL_CORE) -o $@ -c $?
-
-$(WORK_DIR)/RpBoolean.o: $(SRC_DIR)/RpBoolean.cc
-	$(CPP) -fPIC $(DEBUG) $(INCL_CORE) -o $@ -c $?
-
-$(WORK_DIR)/RpOption.o: $(SRC_DIR)/RpOption.cc
-	$(CPP) -fPIC $(DEBUG) $(INCL_CORE) -o $@ -c $?
-
-$(WORK_DIR)/RpAbout.o: $(SRC_DIR)/RpAbout.cc
-	$(CPP) -fPIC $(DEBUG) $(INCL_CORE) -o $@ -c $?
Index: /trunk/src/make.inc
===================================================================
--- /trunk/src/make.inc	(revision 38)
+++ /trunk/src/make.inc	(revision 39)
@@ -24,2 +24,53 @@
 		
 	/sbin/ldconfig -n $(LIB_DIR)
+
+
+#### libRpUnits ###########################################################
+libRpUnits: $(WORK_DIR)/RpUnits.o $(WORK_DIR)/RpUnitsStd.o
+	$(CPP) $(DEGUG) -shared -Wl,-rpath,../lib \
+		-Wl,-soname,$@.so -o $(LIB_DIR)/$@.so.0.0 $^ -lc
+			    
+	/sbin/ldconfig -n $(LIB_DIR)
+
+#### libRpVariable ########################################################
+libRpVariable: $(WORK_DIR)/RpVariable.o $(WORK_DIR)/RpAbout.o
+	$(CPP) $(DEGUG) -shared -Wl,-rpath,../lib \
+		-Wl,-soname,$@.so -o $(LIB_DIR)/$@.so.0.0 $^ -lc
+			    
+	/sbin/ldconfig -n $(LIB_DIR)
+
+#### libRpNumber ##########################################################
+libRpNumber: $(WORK_DIR)/RpNumber.o libRpUnits libRpVariable
+	$(CPP) $(DEGUG) -shared -Wl,-rpath,../lib \
+		-Wl,-soname,$@.so -o $(LIB_DIR)/$@.so.0.0 $< -lc $(LIB_RP_UNITS) $(LIB_RP_VARIABLE)
+			    
+	/sbin/ldconfig -n $(LIB_DIR)
+
+#### libRpString ##########################################################
+libRpString: $(WORK_DIR)/RpString.o libRpVariable
+	$(CPP) $(DEGUG) -shared -Wl,-rpath,../lib \
+		-Wl,-soname,$@.so -o $(LIB_DIR)/$@.so.0.0 $< -lc $(LIB_RP_VARIABLE)
+			    
+	/sbin/ldconfig -n $(LIB_DIR)
+
+#### libRpBoolean ##########################################################
+libRpBoolean: $(WORK_DIR)/RpBoolean.o libRpVariable
+	$(CPP) $(DEGUG) -shared -Wl,-rpath,../lib \
+		-Wl,-soname,$@.so -o $(LIB_DIR)/$@.so.0.0 $< -lc $(LIB_RP_VARIABLE)
+			    
+	/sbin/ldconfig -n $(LIB_DIR)
+
+#### libRpChoice ##########################################################
+libRpChoice: $(WORK_DIR)/RpChoice.o libRpVariable libRpOption
+	$(CPP) $(DEGUG) -shared -Wl,-rpath,../lib \
+		-Wl,-soname,$@.so -o $(LIB_DIR)/$@.so.0.0 $< -lc $(LIB_RP_VARIABLE) $(LIB_RP_OPTION)
+			    
+	/sbin/ldconfig -n $(LIB_DIR)
+
+#### libRpOption ##########################################################
+libRpOption: $(WORK_DIR)/RpOption.o $(WORK_DIR)/RpAbout.o 
+	$(CPP) $(DEGUG) -shared -Wl,-rpath,../lib \
+		-Wl,-soname,$@.so -o $(LIB_DIR)/$@.so.0.0 $< -lc $(LIB_RP_ABOUT)
+			    
+	/sbin/ldconfig -n $(LIB_DIR)
+